/* ... */
/* this file is part of netrafd project */
/* Copyright (c) 2005 M.S. */


#ifndef __NETRAF_GUI_
#define __NETRAF_GUI_ 1

#include <pthread.h>
#include <ncurses.h>

#define ALIGN_LEFT 1001
#define ALIGN_CENTER 1002
#define ALIGN_RIGHT 1003




/**
  Starts GUI (ncurses) mode and prepairing color_pairs.
  @return  -1 if error
*/
int begin_gui_mode(void);




/**
  Ends GUI (ncurses) mode and flushing desktop.
*/
void end_gui_mode(void);




/**
  Used to refresh screen "thread-safely".
*/
__inline__ void update_screen(void);




/**
  Fills window with one character.
  @param win  Pointer to WINDOW (curses) structure
  @param c  With char 'c' window 'win' will be filled
  @param attribute  ncurses COLOR_PAIR of given char
*/
void draw_background(WINDOW *win, char c, long attribute);




/**
  Prints horizontal bar with:
  @param text  Text to write
  @param y  Vertical position
  @param align  Horizontal text alignment (ALIGN_LEFT, ALIGN_CENTER, ALIGN_RIGHT)
  @param attribute  ncurses COLOR_PAIR
*/
void draw_bar(WINDOW *win, const char *text, int y, int align, long attribute);




/**
  Used to delete all specified chars at end of string.
  @param text  Text to change
  @param ch  Char-pattern to delete from tail
*/
void delete_suffix(char *text, char ch);




#endif
