/* ... */
/* this file is part of netrafd project */
/* Copyright (c) 2005 M.S. */


#include "main.h"




int main(int argc, char *argv[]){
  MENU_T *menu;
  ITEM *main_item = NULL, *sub_item = NULL;
  int ch;


  /* initiaize NCURSES mode */
  begin_gui_mode();

  /* draw bars, menus etc... */
  draw_background(stdscr, ' ', COLOR_PAIR(0));
  draw_bar(stdscr,
	   "netrafd Menu System DEMO (http://netrafd.sourceforge.net/)",
           0,
	   ALIGN_CENTER,
	   COLOR_PAIR(1) | A_BOLD);
  draw_bar(stdscr,
	   " [F9]-menu  [F10]-exit ",
           LINES - 1,
	   ALIGN_LEFT,
	   COLOR_PAIR(0) | A_REVERSE);

  /* menu creation */
  menu = create_menu(COLOR_PAIR(5) | A_BOLD, COLOR_PAIR(0) | A_REVERSE,
  	             main_menu_choices, main_menu_choices,
                     function_menu_choices, function_menu_descriptions,
                     filter_menu_choices, filter_menu_descriptions,
                     help_menu_choices, help_menu_descriptions);

  /* it is necessary to "pretend" menu bar while it is inacive */
  draw_bar(stdscr,
           " Function    Filter      Help ",
	   1,
	   ALIGN_LEFT,
	   menu_back(menu->menu));

  /* print some labels */
  wattron(stdscr, COLOR_PAIR(8) | A_BOLD);
  mvwprintw(stdscr, 10, 10, "Main Item: ");
  mvwprintw(stdscr, 11, 10, " Sub Item: ");
  wattroff(stdscr, COLOR_PAIR(8) | A_BOLD);

  /* refresh screen */
  update_screen();
  
  /* main, keyboard input, "command processing" loop */
  for(;;){
    ch = wgetch(stdscr);
      switch(ch){

        /* process main menu */
        case KEY_F(9):
	  /* below - example how to recognize what is selected */
          if(process_main_menu(menu, &main_item, &sub_item) != E_NO_MATCH){
            if(strcmp(item_name(sub_item), " Exit ") == 0){
              destroy_menu(menu);
              end_gui_mode();
              exit(EXIT_SUCCESS);


	    }else{
	      /* we can print what was selected */
	      wattron(stdscr, COLOR_PAIR(6) | A_REVERSE | A_BOLD);
	      mvwprintw(stdscr, 10, 21, "                               ");
	      mvwprintw(stdscr, 11, 21, "                               ");
	      mvwprintw(stdscr, 10, 21, "%s", item_name(main_item));
	      mvwprintw(stdscr, 11, 21, "%s", item_name(sub_item));
	      wattroff(stdscr, COLOR_PAIR(6) | A_REVERSE | A_BOLD);
	    }

            update_screen();
          }
	  break;

        /* immediately exit program */
        case KEY_F(10):
          destroy_menu(menu);
          end_gui_mode();
          exit(EXIT_SUCCESS);
	  break;

        default:
          break;  

      }      /* end switch(ch) ... */
    update_screen();
  }      /* end for(;;)... */


  /* hmm... I think it will be some kind of miracle if program control reaches this point... :) */
  destroy_menu(menu);
  end_gui_mode();
  exit(EXIT_SUCCESS);
}
